StdDelegatingSerializer
Date: 2016-12-04

com.fasterxml.jackson.databind.ser.std

## Class StdDelegatingSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<java.lang.Object>
    - - com.fasterxml.jackson.databind.ser.std.StdDelegatingSerializer

- All Implemented Interfaces:
    JsonFormatVisitable, SchemaAware, ContextualSerializer, ResolvableSerializer, java.io.Serializable

      public class StdDelegatingSerializer
      extends StdSerializer<java.lang.Object>
      implements ContextualSerializer, ResolvableSerializer, JsonFormatVisitable, SchemaAware

  Serializer implementation where given Java type is first converted to an intermediate "delegate type" (using a configured `Converter`, and then this delegate value is serialized by Jackson.

  Note that although types may be related, they must not be same; trying to do this will result in an exception.

  Since:
    2.1
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `JsonSerializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Converter<java.lang.Object,?>` | `_converter`
    `protected JsonSerializer<java.lang.Object>` | `_delegateSerializer` Underlying serializer for type `T`.
    `protected JavaType` | `_delegateType` Fully resolved delegate type, with generic information if any available.

    - ### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `_handledType`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StdDelegatingSerializer(java.lang.Class<T> cls, Converter<T,?> converter)`
    `StdDelegatingSerializer(Converter<?,?> converter)`
    `StdDelegatingSerializer(Converter<java.lang.Object,?> converter, JavaType delegateType, JsonSerializer<?> delegateSerializer)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JsonSerializer<java.lang.Object>` | `_findSerializer(java.lang.Object value, SerializerProvider serializers)` Helper method used for locating serializer to use in dynamic use case, where actual type value gets converted to is not specified beyond basic `Object`, and where serializer needs to be located dynamically based on actual value type.
    `void` | `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
    `protected java.lang.Object` | `convertValue(java.lang.Object value)` Method called to convert from source Java value into delegate value (which will be serialized using standard Jackson serializer for delegate type)
    `JsonSerializer<?>` | `createContextual(SerializerProvider provider, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
    `protected Converter<java.lang.Object,?>` | `getConverter()`
    `JsonSerializer<?>` | `getDelegatee()` Accessor that can be used to determine if this serializer uses another serializer for actual serialization, by delegating calls.
    `JsonNode` | `getSchema(SerializerProvider provider, java.lang.reflect.Type typeHint)` Default implementation simply claims type is "string"; usually overriden by custom serializers.
    `JsonNode` | `getSchema(SerializerProvider provider, java.lang.reflect.Type typeHint, boolean isOptional)` Default implementation simply claims type is "string"; usually overriden by custom serializers.
    `boolean` | `isEmpty(java.lang.Object value)` Deprecated.
    `boolean` | `isEmpty(SerializerProvider prov, java.lang.Object value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
    `void` | `resolve(SerializerProvider provider)` Method called after `SerializerProvider` has registered the serializer, but before it has returned it to the caller.
    `void` | `serialize(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
    `void` | `serializeWithType(java.lang.Object value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
    `protected StdDelegatingSerializer` | `withDelegate(Converter<java.lang.Object,?> converter, JavaType delegateType, JsonSerializer<?> delegateSerializer)` Method used for creating resolved contextual instances.

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `createObjectNode, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _converter

          protected final Converter<java.lang.Object,?> _converter

    - #### _delegateType

          protected final JavaType _delegateType

      Fully resolved delegate type, with generic information if any available.

    - #### _delegateSerializer

          protected final JsonSerializer<java.lang.Object> _delegateSerializer

      Underlying serializer for type `T`.

  - ### Constructor Detail

    - #### StdDelegatingSerializer

          public StdDelegatingSerializer(Converter<?,?> converter)

    - #### StdDelegatingSerializer

          public StdDelegatingSerializer(java.lang.Class<T> cls,
                                 Converter<T,?> converter)

    - #### StdDelegatingSerializer

          public StdDelegatingSerializer(Converter<java.lang.Object,?> converter,
                                 JavaType delegateType,
                                 JsonSerializer<?> delegateSerializer)

  - ### Method Detail

    - #### withDelegate

          protected StdDelegatingSerializer withDelegate(Converter<java.lang.Object,?> converter,
                                             JavaType delegateType,
                                             JsonSerializer<?> delegateSerializer)

      Method used for creating resolved contextual instances. Must be overridden when sub-classing.

    - #### resolve

          public void resolve(SerializerProvider provider)
                       throws JsonMappingException

      Description copied from interface: `ResolvableSerializer`
      Method called after `SerializerProvider` has registered the serializer, but before it has returned it to the caller. Called object can then resolve its dependencies to other types, including self-references (direct or indirect).

      Note that this method does NOT return serializer, since resolution is not allowed to change actual serializer to use.

      Specified by:
        `resolve` in interface `ResolvableSerializer`
      Parameters:
        `provider` - Provider that has constructed serializer this method is called on.
      Throws:
        `JsonMappingException`

    - #### createContextual

          public JsonSerializer<?> createContextual(SerializerProvider provider,
                                           BeanProperty property)
                                             throws JsonMappingException

      Description copied from interface: `ContextualSerializer`
      Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Specified by:
        `createContextual` in interface `ContextualSerializer`
      Parameters:
        `provider` - Serializer provider to use for accessing config, other serializers
        `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
      Returns:
        Serializer to use for serializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### getConverter

          protected Converter<java.lang.Object,?> getConverter()

    - #### getDelegatee

          public JsonSerializer<?> getDelegatee()

      Description copied from class: `JsonSerializer`
      Accessor that can be used to determine if this serializer uses another serializer for actual serialization, by delegating calls. If so, will return immediate delegate (which itself may delegate to further serializers); otherwise will return null.
      Overrides:
        `getDelegatee` in class `JsonSerializer<java.lang.Object>`
      Returns:
        Serializer this serializer delegates calls to, if null; null otherwise.

    - #### serialize

          public void serialize(java.lang.Object value,
                       com.fasterxml.jackson.core.JsonGenerator gen,
                       SerializerProvider provider)
                         throws java.io.IOException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles.
      Specified by:
        `serialize` in class `StdSerializer<java.lang.Object>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `gen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
      Throws:
        `java.io.IOException`

    - #### serializeWithType

          public void serializeWithType(java.lang.Object value,
                               com.fasterxml.jackson.core.JsonGenerator gen,
                               SerializerProvider provider,
                               TypeSerializer typeSer)
                                 throws java.io.IOException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

      Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

      For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

            // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
            typeSer.writeTypePrefixForScalar(value, gen);
            serialize(value, gen, provider);
            typeSer.writeTypeSuffixForScalar(value, gen);

      and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY`/`END-ARRAY` and `START-OBJECT`/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.
      Overrides:
        `serializeWithType` in class `JsonSerializer<java.lang.Object>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `gen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
        `typeSer` - Type serializer to use for including type information
      Throws:
        `java.io.IOException`

    - #### isEmpty

          @Deprecated
          public boolean isEmpty(java.lang.Object value)

      Deprecated.
      Description copied from class: `JsonSerializer`
      Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

      Default implementation will consider only null values to be empty.

      Overrides:
        `isEmpty` in class `JsonSerializer<java.lang.Object>`

    - #### isEmpty

          public boolean isEmpty(SerializerProvider prov,
                        java.lang.Object value)

      Description copied from class: `JsonSerializer`
      Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

      Default implementation will consider only null values to be empty.

      NOTE: replaces `JsonSerializer.isEmpty(Object)`, which was deprecated in 2.5

      Overrides:
        `isEmpty` in class `JsonSerializer<java.lang.Object>`

    - #### getSchema

          public JsonNode getSchema(SerializerProvider provider,
                           java.lang.reflect.Type typeHint)
                             throws JsonMappingException

      Description copied from class: `StdSerializer`
      Default implementation simply claims type is "string"; usually overriden by custom serializers.
      Specified by:
        `getSchema` in interface `SchemaAware`
      Overrides:
        `getSchema` in class `StdSerializer<java.lang.Object>`
      Parameters:
        `provider` - The serializer provider.
        `typeHint` - A hint about the type.
      Returns:
        Json-schema for this serializer.
      Throws:
        `JsonMappingException`

    - #### getSchema

          public JsonNode getSchema(SerializerProvider provider,
                           java.lang.reflect.Type typeHint,
                           boolean isOptional)
                             throws JsonMappingException

      Description copied from class: `StdSerializer`
      Default implementation simply claims type is "string"; usually overriden by custom serializers.
      Specified by:
        `getSchema` in interface `SchemaAware`
      Overrides:
        `getSchema` in class `StdSerializer<java.lang.Object>`
      Parameters:
        `provider` - The serializer provider.
        `typeHint` - A hint about the type.
        `isOptional` - Is the type optional
      Returns:
        Json-schema for this serializer.
      Throws:
        `JsonMappingException`

    - #### acceptJsonFormatVisitor

          public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                                     JavaType typeHint)
                                       throws JsonMappingException

      Description copied from class: `StdSerializer`
      Default implementation specifies no format. This behavior is usually overriden by custom serializers.
      Specified by:
        `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
      Overrides:
        `acceptJsonFormatVisitor` in class `StdSerializer<java.lang.Object>`
        `typeHint` - Type of element (entity like property) being visited
      Throws:
        `JsonMappingException`

    - #### convertValue

          protected java.lang.Object convertValue(java.lang.Object value)

      Method called to convert from source Java value into delegate value (which will be serialized using standard Jackson serializer for delegate type)

      The default implementation uses configured `Converter` to do conversion.

      Parameters:
        `value` - Value to convert
      Returns:
        Result of conversion

    - #### _findSerializer

          protected JsonSerializer<java.lang.Object> _findSerializer(java.lang.Object value,
                                                         SerializerProvider serializers)
                                                              throws JsonMappingException

      Helper method used for locating serializer to use in dynamic use case, where actual type value gets converted to is not specified beyond basic `Object`, and where serializer needs to be located dynamically based on actual value type.
      Throws:
        `JsonMappingException`
      Since:
        2.6